package com.starbuds.server.api.demo._springmvc.ontroller;

import com.starbuds.server.common.demo.VerifyDemoService;
import lombok.extern.slf4j.Slf4j;
import org.apache.dubbo.config.annotation.Reference;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * springmvc登录demo
 *
 * @author gy
 * @date 2023/8/30
 */

@Slf4j
@RestController
@RequestMapping("/api-demo/v1/login")
public class LoginController {
    @Reference
    private VerifyDemoService verifyDemoService;

    /**
     * 用户名密码登录
     *
     * @param userName
     * @param password
     * @return
     */
    @GetMapping("/byPassword")
    public ResponseEntity<String> byPassword(@RequestParam("userName") String userName,
                                             @RequestParam("password") String password,
                                             @RequestParam("type") int type) {
        // String str = null;
        // str.length();

        log.info("开始");
        if (verifyDemoService.verifyPassword(userName, password)) {
            return ResponseEntity.ok("登录成功");
        }
        log.info("结束");
        return ResponseEntity.ok("登录失败");
    }
}
