package com.starbuds.server.api.demo.util;


import org.apache.commons.lang3.StringUtils;

/**
 * @Author jiangxiaowei
 * @DateTime 2020/7/28 14:47
 * @Description 打码工具
 */
public class MaskUtil {


    /**
     * 用户身份证号码的打码隐藏加星号加*
     *
     * @return 处理完成的身份证
     */
    public static String idCardMask(String idCardNum) {
        String res = "";
        if (!StringUtils.isEmpty(idCardNum)) {
            StringBuilder stringBuilder = new StringBuilder(idCardNum);
            res = stringBuilder.replace(6, 14, "********").toString();
        }
        return res;
    }

    /**
     * 用户电话号码的打码隐藏加星号加*
     *
     * @return 处理完成的身份证
     */
    public static String phoneMask(String phone) {
        String res = "";
        if (!StringUtils.isEmpty(phone)) {
            StringBuilder stringBuilder = new StringBuilder(phone);
            res = stringBuilder.replace(3, 7, "****").toString();
        }
        return res;
    }

    /**
     * 银行卡的打码隐藏加星号加*
     *
     * @return 处理完成的身份证
     */
    public static String bankcardMask(String phone) {
        String res = "";
        if (!StringUtils.isEmpty(phone)) {
            StringBuilder stringBuilder = new StringBuilder(phone);
            res = stringBuilder.replace(0, 15, "**** **** **** **** ").toString();
        }
        return res;
    }

    /**
     * 用户姓名打码隐藏加星号加*
     *
     * @return 处理完成的身份证
     */
    public static String userNameMask(String userName) {
        String res = "";
        if (!StringUtils.isEmpty(userName)) {
            StringBuilder stringBuilder = new StringBuilder(userName);
            String str = "";
            for (int i = 0; i < userName.length() - 1; i++) {
                str += "*";
            }
            res = stringBuilder.replace(0, userName.length() - 1, str).toString();
        }
        return res;
    }

}
