package com.starbuds.server.api.demo.v1.facade;

import com.starbuds.server.common.pojo.api.Result;

import javax.ws.rs.QueryParam;

/**
 * 书籍接口
 *
 * @author gy
 * @date 2023/9/18
 */
public interface BookDemoFacade {

    /**
     * 增加书籍
     *
     * @param bookType
     * @param bookAuthor
     * @param bookName
     * @return
     */
    Result addBook(int bookType, String bookName,String bookAuthor);

    /**
     * 删除书籍
     *
     * @param bookId
     * @return
     */
    Result deleteBook(long bookId);

    /**
     * 更新书籍
     *
     * @param bookId
     * @param bookName
     * @param bookAuthor
     * @return
     */
    Result updateBook(long bookId,String bookName,String bookAuthor);

    /**
     * 获取书籍列表
     *
     * @param bookType 为空时获取全部书籍
     * @param bookName 为空时获取全部书籍
     * @param pageIndex
     * @param pageSize
     * @return
     */
    Result getBookList(int bookType, String bookName, int pageIndex,int pageSize);

    /**
     * 获取作者所有的书对应的音乐列表
     *
     * @param bookAuthor
     * @param pageIndex
     * @param pageSize
     * @return
     */
    Result getBookMusicList(String bookAuthor, int pageIndex,int pageSize);

    /**
     * 搜索书籍
     *
     * @param content
     * @param pageIndex
     * @param pageSize
     * @return
     */
    Result searchBook(String content,int pageIndex,int pageSize);

}
