package com.starbuds.server.api.demo.v1.impl;

import com.starbuds.server.api.demo.v1.facade.LoginDemoFacade;
import com.starbuds.server.common.constant.common.GlobalApiError;
import com.starbuds.server.common.pojo.api.MutableResult;
import com.starbuds.server.common.pojo.api.Result;
import com.starbuds.server.common.demo.VerifyDemoService;
import lombok.extern.slf4j.Slf4j;
import org.apache.dubbo.config.annotation.Reference;
import org.apache.dubbo.rpc.protocol.rest.support.ContentType;
import org.springframework.stereotype.Component;

import javax.annotation.security.PermitAll;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;

/**
 * resteasy登录demo
 *
 * @author gy
 * @date 2023/8/30
 */

@Path("/v1/login")
@Produces(ContentType.APPLICATION_JSON_UTF_8)
@Component
@Slf4j
public class LoginDemoFacadeImpl extends BaseFacade implements LoginDemoFacade {

    @Reference(version = "1.0.0")
    VerifyDemoService verifyDemoService;

    /**
     * 用户名密码登录
     *
     * @param userName 用户名
     * @param password 密码
     * @return
     */
    @GET
    @Path("byPassword")
    @PermitAll
    @Override
    public Result byPassword(@QueryParam("userName") String userName,
                             @QueryParam("password") String password) {
        //只用用在全局异常、入口过滤器中
        //Response.status(Response.Status.UNAUTHORIZED).entity(new Result(GlobalApiError.Unauthorized)).type(ContentType.APPLICATION_JSON_UTF_8).build()
        //return HttpError.ACCESS_DENIED同上;

        //{"code":"OPERATION_FAILED","data":null,"msg":"未找到该房间","success":false}
        //return new Result(GlobalApiError.OperationFailed, "未找到该房间");

        //{"code":"OK","data":null,"msg":"","success":true}
        // return new Result();

        //{"code":"OK","data":"123","msg":"","success":true}
        // return new Result(content);

        //{"code":"OK","data":[],"msg":"","success":true}
        //return new Result(new ArrayList<>());

        //{"code":"OK","data":{"state":"多模板返回"},"msg":"","success":true}
        // content = null;
        // content.length();PageList

        //{"code":"OK","data":{"state":"多模板返回"},"msg":"","success":true}

        // String content = verifyDemoService.sayHelloByName(userName);

        // 验证账号密码
        if(userName == null){
            return new Result(GlobalApiError.OperationFailed,"请输入账号");
        }

        if(password == null){
            return new Result(GlobalApiError.OperationFailed,"请输入密码");
        }

        //账号密码正确
        if(verifyDemoService.verifyPassword(userName, password)){
            MutableResult mResult = new MutableResult();
            mResult.put("userName", userName);
            mResult.put("password", password);
            mResult.put("token", "asdfasdfasdf");
            return mResult.build();
        }

        return new Result(GlobalApiError.OperationFailed);
    }

    /**
     * 测试
     *
     * @return
     */
    @GET
    @Path("test")
    // @PermitAll
    @Override
    public Result test() {
        String name0 = null;
        name0.length();
        try {
            String name = null;
            name.length();
        }catch (Exception e){
            log.info("12312");
            return new Result(GlobalApiError.OperationFailed,"456");
        }

        return new Result(GlobalApiError.OperationFailed,"123");
    }
}
